1# $NetBSD: rc.subr,v 1.67 2006/10/07 11:25:15 elad Exp $
2#
3# Copyright (c) 1997-2004 The NetBSD Foundation, Inc.
4# All rights reserved.
5#
6# This code is derived from software contributed to The NetBSD Foundation
7# by Luke Mewburn.
8#
9# Redistribution and use in source and binary forms, with or without
10# modification, are permitted provided that the following conditions
11# are met:
12# 1. Redistributions of source code must retain the above copyright
13#    notice, this list of conditions and the following disclaimer.
14# 2. Redistributions in binary form must reproduce the above copyright
15#    notice, this list of conditions and the following disclaimer in the
16#    documentation and/or other materials provided with the distribution.
17#
18# THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
19# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
20# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
21# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
22# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
23# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
24# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
25# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
26# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
27# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
28# POSSIBILITY OF SUCH DAMAGE.
29#
30# rc.subr
31#	functions used by various rc scripts
32#
33
34: ${RC_PID:=$$}; export RC_PID
35
36#
37#	Operating System dependent/independent variables
38#
39
40if [ -n "${_rc_subr_loaded}" ]; then
41	return
42fi
43
44_rc_subr_loaded="YES"
45
46SYSCTL="/sbin/sysctl"
47SYSCTL_N="${SYSCTL} -n"
48SYSCTL_W="${SYSCTL}"
49PROTECT="/usr/bin/protect"
50ID="/usr/bin/id"
51IDCMD="if [ -x $ID ]; then $ID -un; fi"
52PS="/bin/ps -ww"
53SERVICE=/usr/sbin/service
54JAIL_CMD=/usr/sbin/jail
55_svcj_generic_params="path=/ mount.nodevfs host=inherit"
56JID=0
57CPUSET="/bin/cpuset"
58
59# rc_service provides the path to the service script that we are executing.
60# This is not being set here in an execution context, necessarily, so it's
61# really just a reasonable guess, and it will get overwritten later if
62# we are executing from some other means than direct execution by service(8)
63# or manual invocation of the service script.  The prime example of this is
64# during system startup, all rc scripts will be invoked via /etc/rc, so
65# run_rc_script will overwrite rc_service with the file being sourced.
66rc_service="$0"
67
68#
69#	functions
70#	---------
71
72# is_verified file
73#	if VERIEXEC is active check that $file is verified
74#
75VERIEXEC="/sbin/veriexec"
76if test -x $VERIEXEC && $VERIEXEC -i active > /dev/null 2>&1; then
77	is_verified() { $VERIEXEC -x $1; }
78else
79	is_verified() { return 0; }
80fi
81
82# indicate that we have vdot
83_VDOT_SH=:
84
85# current state of O_VERIFY
86o_verify()
87{
88	case $(echo $(set -o)) in
89	*verify" "off*) echo off;;
90	*verify" "on*) echo on;;
91	esac
92}
93
94##
95# o_verify_set want [save]
96#
97# record current state of verify in $save
98# and set it to $want if different
99#
100o_verify_set() {
101	local x=$(o_verify)
102
103	[ -z "$x" ] && return 0
104	[ -z "$2" ] || eval $2=$x
105	[ "$x" = "$1" ] && return 0
106	case "$1" in
107	on)
108		set -o verify
109		;;
110	off)
111		set +o verify
112		;;
113	esac
114}
115
116# for unverified files
117dotted=
118dot()
119{
120	local f verify
121
122	o_verify_set off verify
123	for f in "$@"; do
124		if [ -f $f -a -s $f ]; then
125			dotted="$dotted $f"
126			. $f
127		fi
128	done
129	o_verify_set $verify
130}
131
132# try for verified, fallback to safe
133sdot()
134{
135	local f
136
137	for f in "$@"; do
138		[ -f $f -a -s $f ] || continue
139		vdot $f || safe_dot $f
140	done
141}
142
143# convenience function - skip if not verified
144vdot()
145{
146	local f rc=0 verify
147
148	o_verify_set on verify
149	for f in "$@"; do
150		[ -f $f -a -s $f ] || continue
151		if is_verified $f 2> /dev/null; then
152			dotted="$dotted $f"
153			. $f
154		else
155			rc=80	# EAUTH
156		fi
157	done
158	o_verify_set $verify
159	return $rc
160}
161
162# Exists [test] file ...
163# report the first "file" that passes "test" (default -s).
164Exists()
165{
166	local f _t=-s
167
168	while :; do
169		: 1=$1
170		case "$1" in
171		-?)
172			_t=$1
173			shift
174			;;
175		*)
176			break
177			;;
178		esac
179	done
180
181	for f in "$@"; do
182		[ $_t $f ] || continue
183		echo $f
184		return 0
185	done
186	return 1
187}
188
189# do we have $1 (could be a function)
190have()
191{
192       type "$1" > /dev/null 2>&1
193}
194
195# provide consistent means of logging progress
196rc_log()
197{
198	date "+@ %s [%Y-%m-%d %H:%M:%S %Z] $*"
199}
200
201# only rc_log if tracing enabled
202# and $level >= $RC_LEVEL
203rc_trace()
204{
205	local level=$1; shift
206	local cf=/etc/rc.conf.d/rc_trace
207
208	if [ -z "$RC_LEVEL" ]; then
209		[ -f $cf ] || return
210		if [ -s $cf ]; then
211			# don't try to set RC_LEVEL without sed
212			if [ -n "$SED" ]; then
213				RC_LEVEL=$($SED -n '/^RC_LEVEL=/ { s/.*=//p;q; }' $cf)
214				RC_LEVEL=${RC_LEVEL:-0}
215			fi
216		else
217			RC_LEVEL=0
218		fi
219	fi
220	[ ${RC_LEVEL:-0} -ge ${level:-0} ] || return
221	rc_log "$@"
222}
223
224# list_vars pattern
225#	List variables matching glob pattern.
226#
227list_vars()
228{
229	# Localize 'set' option below.
230	local -
231	local IFS=$'\n' line varname
232
233	# Disable path expansion in unquoted 'for' parameters below.
234	set -o noglob
235
236	for line in $(set); do
237		varname="${line%%=*}"
238
239		case "$varname" in
240		"$line"|*[!a-zA-Z0-9_]*)
241			continue
242			;;
243		$1)
244			echo $varname
245			;;
246		esac
247	done
248}
249
250# set_rcvar [var] [defval] [desc]
251#
252#	Echo or define a rc.conf(5) variable name.  Global variable
253#	$rcvars is used.
254#
255#	If no argument is specified, echo "${name}_enable".
256#
257#	If only a var is specified, echo "${var}_enable".
258#
259#	If var and defval are specified, the ${var} is defined as
260#	rc.conf(5) variable and the default value is ${defvar}.  An
261#	optional argument $desc can also be specified to add a
262#	description for that.
263#
264set_rcvar()
265{
266	local _var
267
268	case $# in
269	0)	echo ${name}_enable ;;
270	1)	echo ${1}_enable ;;
271	*)
272		debug "set_rcvar: \$$1=$2 is added" \
273		    " as a rc.conf(5) variable."
274		_var=$1
275		rcvars="${rcvars# } $_var"
276		eval ${_var}_defval=\"$2\"
277		shift 2
278		eval ${_var}_desc=\"$*\"
279	;;
280	esac
281}
282
283# set_rcvar_obsolete oldvar [newvar] [msg]
284#	Define obsolete variable.
285#	Global variable $rcvars_obsolete is used.
286#
287set_rcvar_obsolete()
288{
289	local _var
290	_var=$1
291	debug "set_rcvar_obsolete: \$$1(old) -> \$$2(new) is defined"
292
293	rcvars_obsolete="${rcvars_obsolete# } $1"
294	eval ${1}_newvar=\"$2\"
295	shift 2
296	eval ${_var}_obsolete_msg=\"$*\"
297}
298
299#
300# force_depend script [rcvar]
301#	Force a service to start. Intended for use by services
302#	to resolve dependency issues.
303#	$1 - filename of script, in /etc/rc.d, to run
304#	$2 - name of the script's rcvar (minus the _enable)
305#
306force_depend()
307{
308	local _depend _dep_rcvar
309
310	_depend="$1"
311	_dep_rcvar="${2:-$1}_enable"
312
313	[ -n "$rc_fast" ] && ! checkyesno always_force_depends &&
314	    checkyesno $_dep_rcvar && return 0
315
316	/etc/rc.d/${_depend} forcestatus >/dev/null 2>&1 && return 0
317
318	info "${name} depends on ${_depend}, which will be forced to start."
319	if ! /etc/rc.d/${_depend} forcestart; then
320		warn "Unable to force ${_depend}. It may already be running."
321		return 1
322	fi
323}
324
325#
326# checkyesno var
327#	Test $1 variable, and warn if not set to YES or NO.
328#	Return 0 if it's "yes" (et al), nonzero otherwise.
329#
330checkyesno()
331{
332	eval _value=\$${1}
333	debug "checkyesno: $1 is set to $_value."
334	case $_value in
335
336		#	"yes", "true", "on", or "1"
337	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
338		return 0
339		;;
340
341		#	"no", "false", "off", or "0"
342	[Nn][Oo]|[Ff][Aa][Ll][Ss][Ee]|[Oo][Ff][Ff]|0)
343		return 1
344		;;
345	*)
346		warn "\$${1} is not set properly - see rc.conf(5)."
347		return 1
348		;;
349	esac
350}
351
352#
353# reverse_list list
354#	print the list in reverse order
355#
356reverse_list()
357{
358	_revlist=
359	for _revfile; do
360		_revlist="$_revfile $_revlist"
361	done
362	echo $_revlist
363}
364
365# stop_boot always
366#	If booting directly to multiuser or $always is enabled,
367#	send SIGTERM to the parent (/etc/rc) to abort the boot.
368#	Otherwise just exit.
369#
370stop_boot()
371{
372	local always
373
374	case $1 in
375		#	"yes", "true", "on", or "1"
376	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
377		always=true
378		;;
379	*)
380		always=false
381		;;
382	esac
383	if [ "$autoboot" = yes -o "$always" = true ]; then
384		echo "ERROR: ABORTING BOOT (sending SIGTERM to parent)!"
385		kill -TERM ${RC_PID}
386	fi
387	exit 1
388}
389
390#
391# mount_critical_filesystems type
392#	Go through the list of critical filesystems as provided in
393#	the rc.conf(5) variable $critical_filesystems_${type}, checking
394#	each one to see if it is mounted, and if it is not, mounting it.
395#
396mount_critical_filesystems()
397{
398	eval _fslist=\$critical_filesystems_${1}
399	for _fs in $_fslist; do
400		mount | (
401			_ismounted=false
402			while read what _on on _type type; do
403				if [ $on = $_fs ]; then
404					_ismounted=true
405				fi
406			done
407			if $_ismounted; then
408				:
409			else
410				mount $_fs >/dev/null 2>&1
411			fi
412		)
413	done
414}
415
416#
417# check_pidfile pidfile procname [interpreter]
418#	Parses the first line of pidfile for a PID, and ensures
419#	that the process is running and matches procname.
420#	Prints the matching PID upon success, nothing otherwise.
421#	interpreter is optional; see _find_processes() for details.
422#
423check_pidfile()
424{
425	_pidfile=$1
426	_procname=$2
427	_interpreter=$3
428	if [ -z "$_pidfile" -o -z "$_procname" ]; then
429		err 3 'USAGE: check_pidfile pidfile procname [interpreter]'
430	fi
431	if [ ! -f $_pidfile ]; then
432		debug "pid file ($_pidfile): not readable."
433		return
434	fi
435	read _pid _junk < $_pidfile
436	if [ -z "$_pid" ]; then
437		debug "pid file ($_pidfile): no pid in file."
438		return
439	fi
440	_find_processes $_procname ${_interpreter:-.} '-p '"$_pid"
441}
442
443#
444# check_process procname [interpreter]
445#	Ensures that a process (or processes) named procname is running.
446#	Prints a list of matching PIDs.
447#	interpreter is optional; see _find_processes() for details.
448#
449check_process()
450{
451	_procname=$1
452	_interpreter=$2
453	if [ -z "$_procname" ]; then
454		err 3 'USAGE: check_process procname [interpreter]'
455	fi
456	_find_processes $_procname ${_interpreter:-.} '-ax'
457}
458
459#
460# _find_processes procname interpreter psargs
461#	Search for procname in the output of ps generated by psargs.
462#	Prints the PIDs of any matching processes, space separated.
463#
464#	If interpreter == ".", check the following variations of procname
465#	against the first word of each command:
466#		procname
467#		`basename procname`
468#		`basename procname` + ":"
469#		"(" + `basename procname` + ")"
470#		"[" + `basename procname` + "]"
471#
472#	If interpreter != ".", read the first line of procname, remove the
473#	leading #!, normalise whitespace, append procname, and attempt to
474#	match that against each command, either as is, or with extra words
475#	at the end.  As an alternative, to deal with interpreted daemons
476#	using perl, the basename of the interpreter plus a colon is also
477#	tried as the prefix to procname.
478#
479_find_processes()
480{
481	if [ $# -ne 3 ]; then
482		err 3 'USAGE: _find_processes procname interpreter psargs'
483	fi
484	_procname=$1
485	_interpreter=$2
486	_psargs=$3
487
488	_pref=
489	if [ $_interpreter != "." ]; then	# an interpreted script
490		_script="${_chroot}${_chroot:+/}$_procname"
491		if [ -r "$_script" ]; then
492			read _interp < $_script	# read interpreter name
493			case "$_interp" in
494			\#!*)
495				_interp=${_interp#\#!}	# strip #!
496				set -- $_interp
497				case $1 in
498				*/bin/env)
499					shift	# drop env to get real name
500					;;
501				esac
502				if [ $_interpreter != $1 ]; then
503					warn "\$command_interpreter $_interpreter != $1"
504				fi
505				;;
506			*)
507				warn "no shebang line in $_script"
508				set -- $_interpreter
509				;;
510			esac
511		else
512			warn "cannot read shebang line from $_script"
513			set -- $_interpreter
514		fi
515		_interp="$* $_procname"		# cleanup spaces, add _procname
516		_interpbn=${1##*/}
517		_fp_args='_argv'
518		_fp_match='case "$_argv" in
519		    ${_interp}|"${_interp} "*|"[${_interpbn}]"|"${_interpbn}: ${_procname}"*)'
520	else					# a normal daemon
521		_procnamebn=${_procname##*/}
522		_fp_args='_arg0 _argv'
523		_fp_match='case "$_arg0" in
524		    $_procname|$_procnamebn|${_procnamebn}:|"(${_procnamebn})"|"[${_procnamebn}]")'
525	fi
526
527	if checkyesno ${name}_svcj && [ "${_rc_svcj}" != jailing ]; then
528		JID=$(/usr/sbin/jls -j svcj-${name} jid 2>/dev/null)
529
530		case ${JID} in
531		''|*[!0-9]*)
532			# svcj-jail doesn't exist, fallback to host-check
533			JID=0
534			;;
535		esac
536	fi
537	_proccheck="\
538		$PS 2>/dev/null -o pid= -o jid= -o command= $_psargs"' |
539		while read _npid _jid '"$_fp_args"'; do
540			'"$_fp_match"'
541				if [ "$JID" -eq "$_jid" ];
542				then echo -n "$_pref$_npid";
543				_pref=" ";
544				fi
545				;;
546			esac
547		done'
548
549#	debug "in _find_processes: proccheck is ($_proccheck)."
550	eval $_proccheck
551}
552
553# sort_lite [-b] [-n] [-k POS] [-t SEP]
554#	A lite version of sort(1) (supporting a few options) that can be used
555#	before the real sort(1) is available (e.g., in scripts that run prior
556#	to mountcritremote). Requires only shell built-in functionality.
557#
558sort_lite()
559{
560	local funcname=sort_lite
561	local sort_sep="$IFS" sort_ignore_leading_space=
562	local sort_field=0 sort_strict_fields= sort_numeric=
563	local nitems=0 skip_leading=0 trim=
564
565	local OPTIND flag
566	while getopts bnk:t: flag; do
567		case "$flag" in
568		b) sort_ignore_leading_space=1 ;;
569		n) sort_numeric=1 sort_ignore_leading_space=1 ;;
570		k) sort_field="${OPTARG%%,*}" ;; # only up to first comma
571			# NB: Unlike sort(1) only one POS allowed
572		t) sort_sep="$OPTARG"
573		   if [ ${#sort_sep} -gt 1 ]; then
574		   	echo "$funcname: multi-character tab \`$sort_sep'" >&2
575		   	return 1
576		   fi
577		   sort_strict_fields=1
578		   ;;
579		\?) return 1 ;;
580		esac
581	done
582	shift $(( $OPTIND - 1 ))
583
584	# Create transformation pattern to trim leading text if desired
585	case "$sort_field" in
586	""|[!0-9]*|*[!0-9.]*)
587		echo "$funcname: invalid sort field \`$sort_field'" >&2
588		return 1
589		;;
590	*.*)
591		skip_leading=${sort_field#*.} sort_field=${sort_field%%.*}
592		while [ ${skip_leading:-0} -gt 1 ] 2> /dev/null; do
593			trim="$trim?" skip_leading=$(( $skip_leading - 1 ))
594		done
595	esac
596
597	# Copy input to series of local numbered variables
598	# NB: IFS of NULL preserves leading whitespace
599	local LINE
600	while IFS= read -r LINE || [ "$LINE" ]; do
601		nitems=$(( $nitems + 1 ))
602		local src_$nitems="$LINE"
603	done
604
605	#
606	# Sort numbered locals using insertion sort
607	#
608	local curitem curitem_orig curitem_mod curitem_haskey
609	local dest dest_orig dest_mod dest_haskey
610	local d gt n
611	local i=1
612	while [ $i -le $nitems ]; do
613		curitem_haskey=1 # Assume sort field (-k POS) exists
614		eval curitem=\"\$src_$i\"
615		curitem_mod="$curitem" # for modified comparison
616		curitem_orig="$curitem" # for original comparison
617
618		# Trim leading whitespace if desired
619		if [ "$sort_ignore_leading_space" ]; then
620			while case "$curitem_orig" in
621				[$IFS]*) : ;; *) false; esac
622			do
623				curitem_orig="${curitem_orig#?}"
624			done
625			curitem_mod="$curitem_orig"
626		fi
627
628		# Shift modified comparison value if sort field (-k POS) is > 1
629		n=$sort_field
630		while [ $n -gt 1 ]; do
631			case "$curitem_mod" in
632			*[$sort_sep]*)
633				# Cut text up-to (and incl.) first separator
634				curitem_mod="${curitem_mod#*[$sort_sep]}"
635
636				# Skip NULLs unless strict field splitting
637				[ "$sort_strict_fields" ] ||
638					[ "${curitem_mod%%[$sort_sep]*}" ] ||
639					[ $n -eq 2 ] ||
640					continue
641				;;
642			*)
643				# Asked for a field that doesn't exist
644				curitem_haskey= break
645			esac
646			n=$(( $n - 1 ))
647		done
648
649		# Trim trailing words if sort field >= 1
650		[ $sort_field -ge 1 -a "$sort_numeric" ] &&
651			curitem_mod="${curitem_mod%%[$sort_sep]*}"
652
653		# Apply optional trim (-k POS.TRIM) to cut leading characters
654		curitem_mod="${curitem_mod#$trim}"
655
656		# Determine the type of modified comparison to use initially
657		# NB: Prefer numerical if requested but fallback to standard
658		case "$curitem_mod" in
659		""|[!0-9]*) # NULL or begins with non-number
660			gt=">"
661			[ "$sort_numeric" ] && curitem_mod=0
662			;;
663		*)
664			if [ "$sort_numeric" ]; then
665				gt="-gt"
666				curitem_mod="${curitem_mod%%[!0-9]*}"
667					# NB: trailing non-digits removed
668					# otherwise numeric comparison fails
669			else
670				gt=">"
671			fi
672		esac
673
674		# If first time through, short-circuit below position-search
675		if [ $i -le 1 ]; then
676			d=0
677		else
678			d=1
679		fi
680
681		#
682		# Find appropriate element position
683		#
684		while [ $d -gt 0 ]
685		do
686			dest_haskey=$curitem_haskey
687			eval dest=\"\$dest_$d\"
688			dest_mod="$dest" # for modified comparison
689			dest_orig="$dest" # for original comparison
690
691			# Trim leading whitespace if desired
692			if [ "$sort_ignore_leading_space" ]; then
693				while case "$dest_orig" in
694					[$IFS]*) : ;; *) false; esac
695				do
696					dest_orig="${dest_orig#?}"
697				done
698				dest_mod="$dest_orig"
699			fi
700
701			# Shift modified value if sort field (-k POS) is > 1
702			n=$sort_field
703			while [ $n -gt 1 ]; do
704				case "$dest_mod" in
705				*[$sort_sep]*)
706					# Cut text up-to (and incl.) 1st sep
707					dest_mod="${dest_mod#*[$sort_sep]}"
708
709					# Skip NULLs unless strict fields
710					[ "$sort_strict_fields" ] ||
711					    [ "${dest_mod%%[$sort_sep]*}" ] ||
712					    [ $n -eq 2 ] ||
713					    continue
714					;;
715				*)
716					# Asked for a field that doesn't exist
717					dest_haskey= break
718				esac
719				n=$(( $n - 1 ))
720			done
721
722			# Trim trailing words if sort field >= 1
723			[ $sort_field -ge 1 -a "$sort_numeric" ] &&
724				dest_mod="${dest_mod%%[$sort_sep]*}"
725
726			# Apply optional trim (-k POS.TRIM), cut leading chars
727			dest_mod="${dest_mod#$trim}"
728
729			# Determine type of modified comparison to use
730			# NB: Prefer numerical if requested, fallback to std
731			case "$dest_mod" in
732			""|[!0-9]*) # NULL or begins with non-number
733				gt=">"
734				[ "$sort_numeric" ] && dest_mod=0
735				;;
736			*)
737				if [ "$sort_numeric" ]; then
738					gt="-gt"
739					dest_mod="${dest_mod%%[!0-9]*}"
740						# NB: kill trailing non-digits
741						# for numeric comparison safety
742				else
743					gt=">"
744				fi
745			esac
746
747			# Break if we've found the proper element position
748			if [ "$curitem_haskey" -a "$dest_haskey" ]; then
749				if [ "$dest_mod" = "$curitem_mod" ]; then
750					[ "$dest_orig" ">" "$curitem_orig" ] &&
751						break
752				elif [ "$dest_mod" $gt "$curitem_mod" ] \
753					2> /dev/null
754				then
755					break
756				fi
757			else
758				[ "$dest_orig" ">" "$curitem_orig" ] && break
759			fi
760
761			# Break if we've hit the end
762			[ $d -ge $i ] && break
763
764			d=$(( $d + 1 ))
765		done
766
767		# Shift remaining positions forward, making room for new item
768		n=$i
769		while [ $n -ge $d ]; do
770			# Shift destination item forward one placement
771			eval dest_$(( $n + 1 ))=\"\$dest_$n\"
772			n=$(( $n - 1 ))
773		done
774
775		# Place the element
776		if [ $i -eq 1 ]; then
777			local dest_1="$curitem"
778		else
779			local dest_$d="$curitem"
780		fi
781
782		i=$(( $i + 1 ))
783	done
784
785	# Print sorted results
786	d=1
787	while [ $d -le $nitems ]; do
788		eval echo \"\$dest_$d\"
789		d=$(( $d + 1 ))
790	done
791}
792
793#
794# wait_for_pids pid [pid ...]
795#	spins until none of the pids exist
796#
797wait_for_pids()
798{
799	local _list _prefix _nlist _j
800
801	_list="$@"
802	if [ -z "$_list" ]; then
803		return
804	fi
805	_prefix=
806	while true; do
807		_nlist="";
808		for _j in $_list; do
809			if kill -0 $_j 2>/dev/null; then
810				_nlist="${_nlist}${_nlist:+ }$_j"
811				[ -n "$_prefix" ] && sleep 1
812			fi
813		done
814		if [ -z "$_nlist" ]; then
815			break
816		fi
817		_list=$_nlist
818		echo -n ${_prefix:-"Waiting for PIDS: "}$_list
819		_prefix=", "
820		pwait $_list 2>/dev/null
821	done
822	if [ -n "$_prefix" ]; then
823		echo "."
824	fi
825}
826
827#
828# get_pidfile_from_conf string file
829#
830#	Takes a string to search for in the specified file.
831#	Ignores lines with traditional comment characters.
832#
833# Example:
834#
835# if get_pidfile_from_conf string file; then
836#	pidfile="$_pidfile_from_conf"
837# else
838#	pidfile='appropriate default'
839# fi
840#
841get_pidfile_from_conf()
842{
843	if [ -z "$1" -o -z "$2" ]; then
844		err 3 "USAGE: get_pidfile_from_conf string file ($name)"
845	fi
846
847	local string file line
848
849	string="$1" ; file="$2"
850
851	if [ ! -s "$file" ]; then
852		err 3 "get_pidfile_from_conf: $file does not exist ($name)"
853	fi
854
855	while read line; do
856		case "$line" in
857		*[#\;]*${string}*)	continue ;;
858		*${string}*)		break ;;
859		esac
860	done < $file
861
862	if [ -n "$line" ]; then
863		line=${line#*/}
864		_pidfile_from_conf="/${line%%[\"\;]*}"
865	else
866		return 1
867	fi
868}
869
870#
871# check_startmsgs
872#	If rc_quiet is set (usually as a result of using faststart at
873#	boot time) check if rc_startmsgs is enabled.
874#
875check_startmsgs()
876{
877	if [ -n "$rc_quiet" ]; then
878		checkyesno rc_startmsgs
879	else
880		return 0
881	fi
882}
883
884#
885# startmsg
886#	Preferred method to use when displaying start messages in lieu of echo.
887#
888startmsg()
889{
890	check_startmsgs && echo "$@"
891}
892
893#
894# run_rc_command argument
895#	Search for argument in the list of supported commands, which is:
896#		"start stop restart rcvar status poll ${extra_commands}"
897#	If there's a match, run ${argument}_cmd or the default method
898#	(see below).
899#
900#	If argument has a given prefix, then change the operation as follows:
901#		Prefix	Operation
902#		------	---------
903#		fast	Skip the pid check, and set rc_fast=yes, rc_quiet=yes
904#		force	Set ${rcvar} to YES, and set rc_force=yes
905#		one	Set ${rcvar} to YES
906#		quiet	Don't output some diagnostics, and set rc_quiet=yes
907#
908#	The following globals are used:
909#
910#	Name		Needed	Purpose
911#	----		------	-------
912#	name		y	Name of script.
913#
914#	command		n	Full path to command.
915#				Not needed if ${rc_arg}_cmd is set for
916#				each keyword.
917#
918#	command_args	n	Optional args/shell directives for command.
919#
920#	command_interpreter n	If not empty, command is interpreted, so
921#				call check_{pidfile,process}() appropriately.
922#
923#	desc		n	Description of script.
924#
925#	extra_commands	n	List of extra commands supported.
926#
927#	pidfile		n	If set, use check_pidfile $pidfile $command,
928#				otherwise use check_process $command.
929#				In either case, only check if $command is set.
930#
931#	procname	n	Process name to check for instead of $command.
932#
933#	rcvar		n	This is checked with checkyesno to determine
934#				if the action should be run.
935#
936#	${name}_program	n	Full path to command.
937#				Meant to be used in /etc/rc.conf to override
938#				${command}.
939#
940#	${name}_chroot	n	Directory to chroot to before running ${command}
941#				Requires /usr to be mounted.
942#
943#	${name}_chdir	n	Directory to cd to before running ${command}
944#				(if not using ${name}_chroot).
945#
946#	${name}_cpuset	n	A list of CPUs to run ${command} on.
947#				Requires /usr to be mounted.
948#
949#	${name}_flags	n	Arguments to call ${command} with.
950#				NOTE:	$flags from the parent environment
951#					can be used to override this.
952#
953#	${name}_env	n	Environment variables to run ${command} with.
954#
955#	${name}_env_file n	File to source variables to run ${command} with.
956#
957#	${name}_fib	n	Routing table number to run ${command} with.
958#
959#	${name}_nice	n	Nice level to run ${command} at.
960#
961#	${name}_oomprotect n	Don't kill ${command} when swap space is exhausted.
962#
963#	${name}_umask	n	The file creation mask to run ${command} with.
964#
965#	${name}_user	n	User to run ${command} as, using su(1) if not
966#				using ${name}_chroot.
967#				Requires /usr to be mounted.
968#
969#	${name}_group	n	Group to run chrooted ${command} as.
970#				Requires /usr to be mounted.
971#
972#	${name}_groups	n	Comma separated list of supplementary groups
973#				to run the chrooted ${command} with.
974#				Requires /usr to be mounted.
975#
976#	${name}_prepend	n	Command added before ${command}.
977#
978#	${name}_setup	n	Command executed during start, restart and
979#				reload before ${rc_arg}_precmd is run.
980#
981#	${name}_login_class n	Login class to use, else "daemon".
982#
983#	${name}_limits	n	limits(1) to apply to ${command}.
984#
985#	${name}_offcmd	n	If set, run if a service is not enabled.
986#
987#	${rc_arg}_cmd	n	If set, use this as the method when invoked;
988#				Otherwise, use default command (see below)
989#
990#	${rc_arg}_precmd n	If set, run just before performing the
991#				${rc_arg}_cmd method in the default
992#				operation (i.e, after checking for required
993#				bits and process (non)existence).
994#				If this completes with a non-zero exit code,
995#				don't run ${rc_arg}_cmd.
996#
997#	${rc_arg}_postcmd n	If set, run just after performing the
998#				${rc_arg}_cmd method, if that method
999#				returned a zero exit code.
1000#
1001#	required_dirs	n	If set, check for the existence of the given
1002#				directories before running a (re)start command.
1003#
1004#	required_files	n	If set, check for the readability of the given
1005#				files before running a (re)start command.
1006#
1007#	required_modules n	If set, ensure the given kernel modules are
1008#				loaded before running a (re)start command.
1009#				The check and possible loads are actually
1010#				done after start_precmd so that the modules
1011#				aren't loaded in vain, should the precmd
1012#				return a non-zero status to indicate a error.
1013#				If a word in the list looks like "foo:bar",
1014#				"foo" is the KLD file name and "bar" is the
1015#				module name.  If a word looks like "foo~bar",
1016#				"foo" is the KLD file name and "bar" is a
1017#				egrep(1) pattern matching the module name.
1018#				Otherwise the module name is assumed to be
1019#				the same as the KLD file name, which is most
1020#				common.  See load_kld().
1021#
1022#	required_vars	n	If set, perform checkyesno on each of the
1023#				listed variables before running the default
1024#				(re)start command.
1025#
1026#	Default behaviour for a given argument, if no override method is
1027#	provided:
1028#
1029#	Argument	Default behaviour
1030#	--------	-----------------
1031#	start		if !running && checkyesno ${rcvar}
1032#				${command}
1033#
1034#	stop		if ${pidfile}
1035#				rc_pid=$(check_pidfile $pidfile $command)
1036#			else
1037#				rc_pid=$(check_process $command)
1038#			kill $sig_stop $rc_pid
1039#			wait_for_pids $rc_pid
1040#			($sig_stop defaults to TERM.)
1041#
1042#	reload		Similar to stop, except use $sig_reload instead,
1043#			and don't wait_for_pids.
1044#			$sig_reload defaults to HUP.
1045#			Note that `reload' isn't provided by default,
1046#			it should be enabled via $extra_commands.
1047#
1048#	restart		Run `stop' then `start'.
1049#
1050#	status		Show if ${command} is running, etc.
1051#
1052#	poll		Wait for ${command} to exit.
1053#
1054#	rcvar		Display what rc.conf variable is used (if any).
1055#
1056#	enabled		Return true if the service is enabled.
1057#
1058#	describe	Show the service's description
1059#
1060#	extracommands	Show the service's extra commands
1061#
1062#	Variables available to methods, and after run_rc_command() has
1063#	completed:
1064#
1065#	Variable	Purpose
1066#	--------	-------
1067#	rc_arg		Argument to command, after fast/force/one processing
1068#			performed
1069#
1070#	rc_flags	Flags to start the default command with.
1071#			Defaults to ${name}_flags, unless overridden
1072#			by $flags from the environment.
1073#			This variable may be changed by the precmd method.
1074#
1075#	rc_service	Path to the service being executed, in case the service
1076#			needs to re-invoke itself.
1077#
1078#	rc_pid		PID of command (if appropriate)
1079#
1080#	rc_fast		Not empty if "fast" was provided (q.v.)
1081#
1082#	rc_force	Not empty if "force" was provided (q.v.)
1083#
1084#	rc_quiet	Not empty if "quiet" was provided
1085#
1086#
1087run_rc_command()
1088{
1089	_return=0
1090	rc_arg=$1
1091	if [ -z "$name" ]; then
1092		err 3 'run_rc_command: $name is not set.'
1093	fi
1094
1095	DebugOn rc:all rc:all:$rc_arg rc:$name rc:$name:$rc_arg $name:$rc_arg
1096
1097	# Don't repeat the first argument when passing additional command-
1098	# line arguments to the command subroutines.
1099	#
1100	shift 1
1101	rc_extra_args="$*"
1102
1103	_rc_prefix=
1104	case "$rc_arg" in
1105	fast*)				# "fast" prefix; don't check pid
1106		rc_arg=${rc_arg#fast}
1107		rc_fast=yes
1108		rc_quiet=yes
1109		;;
1110	force*)				# "force" prefix; always run
1111		rc_force=yes
1112		_rc_prefix=force
1113		rc_arg=${rc_arg#${_rc_prefix}}
1114		if [ -n "${rcvar}" ]; then
1115			eval ${rcvar}=YES
1116		fi
1117		;;
1118	one*)				# "one" prefix; set ${rcvar}=yes
1119		_rc_prefix=one
1120		rc_arg=${rc_arg#${_rc_prefix}}
1121		if [ -n "${rcvar}" ]; then
1122			eval ${rcvar}=YES
1123		fi
1124		;;
1125	quiet*)				# "quiet" prefix; omit some messages
1126		_rc_prefix=quiet
1127		rc_arg=${rc_arg#${_rc_prefix}}
1128		rc_quiet=yes
1129		;;
1130	esac
1131
1132	eval _override_command=\$${name}_program
1133	command=${_override_command:-$command}
1134
1135	_keywords="start stop restart rcvar enable disable delete enabled describe extracommands $extra_commands"
1136	rc_pid=
1137	_pidcmd=
1138	_procname=${procname:-${command}}
1139
1140	eval _cpuset=\$${name}_cpuset
1141
1142	# Loose validation of the configured cpuset; just make sure it starts
1143	# with a number.  There have also been cases in the past where a hyphen
1144	# in a service name has caused eval errors, which trickle down into
1145	# various variables; don't let a situation like that break a bunch of
1146	# services just because of cpuset(1).
1147	case "$_cpuset" in
1148	[0-9]*)	;;
1149	*)	_cpuset="" ;;
1150	esac
1151
1152	_cpusetcmd=
1153	if [ -n "$_cpuset" ]; then
1154		_cpusetcmd="$CPUSET -l $_cpuset"
1155	fi
1156
1157	# If a specific jail has a specific svcj request, honor it (YES/NO).
1158	# If not (variable empty), evaluate the global svcj catch-all.
1159	# A global YES can be overriden by a specific NO, and a global NO is overriden
1160	# by a specific YES.
1161	eval _svcj=\$${name}_svcj
1162	if [ -z "$_svcj" ]; then
1163		_svcj=${svcj_all_enable}
1164		if [ -z "$_svcj" ]; then
1165			eval ${name}_svcj=NO
1166		fi
1167	fi
1168
1169					# setup pid check command
1170	if [ -n "$_procname" ]; then
1171		if [ -n "$pidfile" ]; then
1172			_pidcmd='rc_pid=$(check_pidfile '"$pidfile $_procname $command_interpreter"')'
1173		else
1174			_pidcmd='rc_pid=$(check_process '"$_procname $command_interpreter"')'
1175		fi
1176		_keywords="${_keywords} status poll"
1177	else
1178		if [ ! -z "${status_cmd}" ]
1179		then
1180			_keywords="${_keywords} status"
1181		fi
1182	fi
1183
1184	if [ -z "$rc_arg" ]; then
1185		rc_usage $_keywords
1186	fi
1187
1188	if [ "$rc_arg" = "enabled" ] ; then
1189		checkyesno ${rcvar}
1190		return $?
1191	fi
1192
1193	if [ -n "$flags" ]; then	# allow override from environment
1194		rc_flags=$flags
1195	else
1196		eval rc_flags=\$${name}_flags
1197	fi
1198	eval _chdir=\$${name}_chdir	_chroot=\$${name}_chroot \
1199	    _nice=\$${name}_nice	_user=\$${name}_user \
1200	    _group=\$${name}_group	_groups=\$${name}_groups \
1201	    _fib=\$${name}_fib		_env=\$${name}_env \
1202	    _prepend=\$${name}_prepend	_login_class=\${${name}_login_class:-daemon} \
1203	    _limits=\$${name}_limits	_oomprotect=\$${name}_oomprotect \
1204	    _setup=\$${name}_setup	_env_file=\$${name}_env_file \
1205	    _umask=\$${name}_umask	_svcj_options=\$${name}_svcj_options
1206
1207	if [ -n "$_env_file" ] && [ -r "${_env_file}" ]; then	# load env from file
1208		set -a
1209		. $_env_file
1210		set +a
1211	fi
1212
1213	if [ -n "$_user" ]; then	# unset $_user if running as that user
1214		if [ "$_user" = "$(eval $IDCMD)" ]; then
1215			unset _user
1216		fi
1217	fi
1218
1219	if [ -n "$_svcj_options" ]; then	# translate service jail options
1220		_svcj_cmd_options=""
1221
1222		for _svcj_option in $_svcj_options; do
1223			case "$_svcj_option" in
1224				mlock)
1225					_svcj_cmd_options="allow.mlock ${_svcj_cmd_options}"
1226					;;
1227				netv4)
1228					_svcj_cmd_options="ip4=inherit allow.reserved_ports ${_svcj_cmd_options}"
1229					;;
1230				netv6)
1231					_svcj_cmd_options="ip6=inherit allow.reserved_ports ${_svcj_cmd_options}"
1232					;;
1233				net_basic)
1234					_svcj_cmd_options="ip4=inherit ip6=inherit allow.reserved_ports ${_svcj_cmd_options}"
1235					;;
1236				net_raw)
1237					_svcj_cmd_options="allow.raw_sockets ${_svcj_cmd_options}"
1238					;;
1239				net_all)
1240					_svcj_cmd_options="allow.socket_af allow.raw_sockets allow.reserved_ports ip4=inherit ip6=inherit ${_svcj_cmd_options}"
1241					;;
1242				nfsd)
1243					_svcj_cmd_options="allow.nfsd enforce_statfs=1 ${_svcj_cmd_options}"
1244					;;
1245				sysvipc)
1246					_svcj_cmd_options="sysvmsg=inherit sysvsem=inherit sysvshm=inherit  ${_svcj_cmd_options}"
1247					;;
1248				vmm)
1249					_svcj_cmd_options="allow.vmm ${_svcj_cmd_options}"
1250					;;
1251				*)
1252					echo ${name}: unknown service jail option: $_svcj_option
1253					;;
1254			esac
1255		done
1256	fi
1257
1258	[ -z "$autoboot" ] && eval $_pidcmd	# determine the pid if necessary
1259
1260	for _elem in $_keywords; do
1261		if [ "$_elem" != "$rc_arg" ]; then
1262			continue
1263		fi
1264					# if ${rcvar} is set, $1 is not "rcvar", "describe",
1265					# "enable", "delete" or "status", and ${rc_pid} is
1266					# not set, run:
1267					#	checkyesno ${rcvar}
1268					# and return if that failed
1269					#
1270		if [ -n "${rcvar}" -a "$rc_arg" != "rcvar" -a "$rc_arg" != "stop" \
1271		    -a "$rc_arg" != "delete" -a "$rc_arg" != "enable" \
1272		    -a "$rc_arg" != "describe" -a "$rc_arg" != "status" ] ||
1273		    [ -n "${rcvar}" -a "$rc_arg" = "stop" -a -z "${rc_pid}" ]; then
1274			if ! checkyesno ${rcvar}; then
1275			    [ "$rc_arg" = "start" ] && _run_rc_offcmd
1276			    if [ -z "${rc_quiet}" ]; then
1277				echo -n "Cannot '${rc_arg}' $name. Set ${rcvar} to "
1278				echo -n "YES in /etc/rc.conf or use 'one${rc_arg}' "
1279				echo "instead of '${rc_arg}'."
1280			    fi
1281			    return 0
1282			fi
1283		fi
1284
1285		if [ $rc_arg = "start" -a -z "$rc_fast" -a -n "$rc_pid" ]; then
1286			if [ -z "$rc_quiet" ]; then
1287				echo 1>&2 "${name} already running? " \
1288				    "(pid=$rc_pid)."
1289			fi
1290			return 1
1291		fi
1292
1293		# if there's a custom ${XXX_cmd},
1294		# run that instead of the default
1295		#
1296		eval _cmd=\$${rc_arg}_cmd \
1297		     _precmd=\$${rc_arg}_precmd \
1298		     _postcmd=\$${rc_arg}_postcmd
1299
1300		if [ -n "$_cmd" ]; then
1301			rc_trace 1 "$_cmd"
1302			if [ -n "$_env" ]; then
1303				eval "export -- $_env"
1304			fi
1305
1306			if [ "${_rc_svcj}" != jailing ]; then
1307				# service can redefine all so
1308				# check for valid setup target
1309				if [ "$rc_arg" = 'start' -o \
1310				    "$rc_arg" = 'restart' -o \
1311				    "$rc_arg" = 'reload' ]; then
1312					_run_rc_setup || \
1313					    warn "failed to setup ${name}"
1314				fi
1315				_run_rc_precmd || return 1
1316			fi
1317			if ! checkyesno ${name}_svcj; then
1318				_run_rc_doit "$_cpusetcmd $_cmd $rc_extra_args" || return 1
1319			else
1320				case "$rc_arg" in
1321				start)
1322					if [ "${_rc_svcj}" != jailing ]; then
1323						_return=1
1324						$JAIL_CMD -c $_svcj_generic_params $_svcj_cmd_options \
1325						    exec.start="${SERVICE} -E _rc_svcj=jailing ${name} ${_rc_prefix}start $rc_extra_args" \
1326						    exec.stop="${SERVICE} -E _rc_svcj=jailing ${name} ${_rc_prefix}stop $rc_extra_args" \
1327						    exec.consolelog="/var/log/svcj_${name}_console.log" \
1328						    name=svcj-${name} && _return=0
1329					else
1330						_run_rc_doit "$_cpusetcmd $_cmd $rc_extra_args" || _return=1
1331					fi
1332					;;
1333				stop)
1334					if [ "${_rc_svcj}" != jailing ]; then
1335						$SERVICE -E _rc_svcj=jailing -j svcj-${name} ${name} ${_rc_prefix}stop $rc_extra_args || _return=1
1336						$JAIL_CMD -r svcj-${name} 2>/dev/null
1337					else
1338						_run_rc_doit "$_cpusetcmd $_cmd $rc_extra_args" || _return=1
1339					fi
1340					;;
1341				restart|status) ;; # no special case needed for svcj or handled somewhere else
1342				*)
1343					eval _rc_svcj_extra_cmd=\$${name}_${rc_arg}_svcj_enable
1344					: ${_rc_svcj_extra_cmd:=NO}
1345					if checkyesno _rc_svcj_extra_cmd && [ "${_rc_svcj}" != jailing ]; then
1346						$SERVICE -v -E _rc_svcj=jailing -j svcj-${name} ${name} ${_rc_prefix}${rc_arg} $rc_extra_args || _return=1
1347					else
1348						_run_rc_doit "$_cpusetcmd $_cmd $rc_extra_args" || _return=1
1349					fi
1350					;;
1351				esac
1352			fi
1353			if [ "${_rc_svcj}" != jailing ]; then
1354				_run_rc_postcmd
1355			fi
1356			return $_return
1357		fi
1358
1359		case "$rc_arg" in	# default operations...
1360
1361		describe)
1362			if [ -n "$desc" ]; then
1363				echo "$desc"
1364			fi
1365			;;
1366
1367		extracommands)
1368			echo "$extra_commands"
1369			;;
1370
1371		enable)
1372			_out=$(/usr/sbin/sysrc -vs "$name" "$rcvar=YES") &&
1373				echo "$name enabled in ${_out%%:*}"
1374			;;
1375
1376		disable)
1377			_out=$(/usr/sbin/sysrc -vs "$name" "$rcvar=NO") &&
1378				echo "$name disabled in ${_out%%:*}"
1379			;;
1380
1381		delete)
1382			_files=
1383			for _file in $(sysrc -lEs "$name"); do
1384				_out=$(sysrc -Fif $_file "$rcvar") && _files="$_files $_file"
1385			done
1386			/usr/sbin/sysrc -x "$rcvar" && echo "$rcvar deleted in ${_files# }"
1387				# delete file in rc.conf.d if desired and empty.
1388			checkyesno service_delete_empty || _files=
1389			for _file in $_files; do
1390				[ "$_file" = "${_file#*/rc.conf.d/}" ] && continue
1391				[ $(/usr/bin/stat -f%z $_file) -gt 0 ] && continue
1392				/bin/rm "$_file" && echo "Empty file $_file removed"
1393			done
1394			;;
1395
1396		status)
1397			_run_rc_precmd || return 1
1398			if [ -n "$rc_pid" ]; then
1399				echo "${name} is running as pid $rc_pid."
1400			else
1401				echo "${name} is not running."
1402				return 1
1403			fi
1404			_run_rc_postcmd
1405			;;
1406
1407		start)
1408			if [ ! -x "${_chroot}${_chroot:+/}${command}" ]; then
1409				warn "run_rc_command: cannot run $command"
1410				return 1
1411			fi
1412
1413			if [ "${_rc_svcj}" != jailing ]; then
1414				_run_rc_setup || warn "failed to setup ${name}"
1415
1416				if ! _run_rc_precmd; then
1417					warn "failed precmd routine for ${name}"
1418					return 1
1419				fi
1420			fi
1421
1422			if checkyesno ${name}_svcj; then
1423				if [ "${_rc_svcj}" != jailing ]; then
1424					$JAIL_CMD -c $_svcj_generic_params $_svcj_cmd_options\
1425					    exec.start="${SERVICE} -E _rc_svcj=jailing ${name} ${_rc_prefix}start $rc_extra_args" \
1426					    exec.stop="${SERVICE} -E _rc_svcj=jailing ${name} ${_rc_prefix}stop $rc_extra_args" \
1427					    exec.consolelog="/var/log/svcj_${name}_console.log" \
1428					    name=svcj-${name} || return 1
1429				fi
1430			fi
1431
1432			# setup the full command to run
1433			#
1434			startmsg "Starting ${name}."
1435			if [ -n "$_chroot" ]; then
1436				_cd=
1437				_doit="\
1438${_nice:+nice -n $_nice }\
1439$_cpusetcmd \
1440${_fib:+setfib -F $_fib }\
1441${_env:+env $_env }\
1442chroot ${_user:+-u $_user }${_group:+-g $_group }${_groups:+-G $_groups }\
1443$_chroot $command $rc_flags $command_args"
1444			else
1445				_cd="${_chdir:+cd $_chdir && }"
1446				_doit="\
1447${_fib:+setfib -F $_fib }\
1448${_env:+env $_env }\
1449$_cpusetcmd $command $rc_flags $command_args"
1450				if [ -n "$_user" ]; then
1451				    _doit="su -m $_user -c 'sh -c \"$_doit\"'"
1452				fi
1453				if [ -n "$_nice" ]; then
1454					if [ -z "$_user" ]; then
1455						_doit="sh -c \"$_doit\""
1456					fi
1457					_doit="nice -n $_nice $_doit"
1458				fi
1459				if [ -n "$_prepend" ]; then
1460					_doit="$_prepend $_doit"
1461				fi
1462			fi
1463
1464			# Prepend default limits
1465			_doit="$_cd limits -C $_login_class $_limits $_doit"
1466
1467			local _really_run_it=true
1468			if checkyesno ${name}_svcj; then
1469				if [ "${_rc_svcj}" != jailing ]; then
1470					_really_run_it=false
1471				fi
1472			fi
1473
1474			if [ "$_really_run_it" = true ]; then
1475				# run the full command
1476				#
1477				if ! _run_rc_doit "$_doit"; then
1478					warn "failed to start ${name}"
1479					return 1
1480				fi
1481			fi
1482
1483			if [ "${_rc_svcj}" != jailing ]; then
1484				# finally, run postcmd
1485				#
1486				_run_rc_postcmd
1487			fi
1488			;;
1489
1490		stop)
1491			if [ -z "$rc_pid" ]; then
1492				[ -n "$rc_fast" ] && return 0
1493				_run_rc_notrunning
1494				return 1
1495			fi
1496
1497			_run_rc_precmd || return 1
1498
1499			# send the signal to stop
1500			#
1501			echo "Stopping ${name}."
1502			_doit=$(_run_rc_killcmd "${sig_stop:-TERM}")
1503			_run_rc_doit "$_doit" || return 1
1504
1505			# wait for the command to exit,
1506			# and run postcmd.
1507			wait_for_pids $rc_pid
1508
1509			if checkyesno ${name}_svcj; then
1510				# remove service jail
1511				$JAIL_CMD -r svcj-${name} 2>/dev/null
1512			fi
1513
1514			_run_rc_postcmd
1515			;;
1516
1517		reload)
1518			if [ -z "$rc_pid" ]; then
1519				_run_rc_notrunning
1520				return 1
1521			fi
1522
1523			_run_rc_setup || warn "failed to setup ${name}"
1524
1525			_run_rc_precmd || return 1
1526
1527			_doit=$(_run_rc_killcmd "${sig_reload:-HUP}")
1528			_run_rc_doit "$_doit" || return 1
1529
1530			_run_rc_postcmd
1531			;;
1532
1533		restart)
1534			_run_rc_setup || warn "failed to setup ${name}"
1535
1536			# prevent restart being called more
1537			# than once by any given script
1538			#
1539			if ${_rc_restart_done:-false}; then
1540				return 0
1541			fi
1542			_rc_restart_done=true
1543
1544			_run_rc_precmd || return 1
1545
1546			# run those in a subshell to keep global variables
1547			( run_rc_command ${_rc_prefix}stop $rc_extra_args )
1548			( run_rc_command ${_rc_prefix}start $rc_extra_args )
1549			_return=$?
1550			[ $_return -ne 0 ] && [ -z "$rc_force" ] && return 1
1551
1552			_run_rc_postcmd
1553			;;
1554
1555		poll)
1556			_run_rc_precmd || return 1
1557			if [ -n "$rc_pid" ]; then
1558				wait_for_pids $rc_pid
1559			fi
1560			_run_rc_postcmd
1561			;;
1562
1563		rcvar)
1564			echo -n "# $name"
1565			if [ -n "$desc" ]; then
1566				echo " : $desc"
1567			else
1568				echo ""
1569			fi
1570			echo "#"
1571			# Get unique vars in $rcvar $rcvars
1572			for _v in $rcvar $rcvars; do
1573				case $v in
1574				$_v\ *|\ *$_v|*\ $_v\ *) ;;
1575				*)	v="${v# } $_v" ;;
1576				esac
1577			done
1578
1579			# Display variables.
1580			for _v in $v; do
1581				if [ -z "$_v" ]; then
1582					continue
1583				fi
1584
1585				eval _desc=\$${_v}_desc
1586				eval _defval=\$${_v}_defval
1587				_h="-"
1588
1589				eval echo \"$_v=\\\"\$$_v\\\"\"
1590				# decode multiple lines of _desc
1591				while [ -n "$_desc" ]; do
1592					case $_desc in
1593					*^^*)
1594						echo "# $_h ${_desc%%^^*}"
1595						_desc=${_desc#*^^}
1596						_h=" "
1597						;;
1598					*)
1599						echo "# $_h ${_desc}"
1600						break
1601						;;
1602					esac
1603				done
1604				echo "#   (default: \"$_defval\")"
1605			done
1606			echo ""
1607			;;
1608
1609		*)
1610			rc_usage $_keywords
1611			;;
1612
1613		esac
1614
1615		# Apply protect(1) to the PID if ${name}_oomprotect is set.
1616		case "$rc_arg" in
1617		start)
1618			# We cannot use protect(1) inside jails.
1619			if [ -n "$_oomprotect" ] && [ -f "${PROTECT}" ] &&
1620			    [ "$(sysctl -n security.jail.jailed)" -eq 0 ]; then
1621				[ -z "${rc_pid}" ] && eval $_pidcmd
1622				case $_oomprotect in
1623				[Aa][Ll][Ll])
1624					${PROTECT} -d -i -p ${rc_pid}
1625					;;
1626				[Yy][Ee][Ss])
1627					${PROTECT} -p ${rc_pid}
1628					;;
1629				esac
1630			fi
1631		;;
1632		esac
1633
1634		return $_return
1635	done
1636
1637	echo 1>&2 "$0: unknown directive '$rc_arg'."
1638	rc_usage $_keywords
1639	# not reached
1640}
1641
1642#
1643# Helper functions for run_rc_command: common code.
1644# They use such global variables besides the exported rc_* ones:
1645#
1646#	name	       R/W
1647#	------------------
1648#	_offcmd		R
1649#	_precmd		R
1650#	_postcmd	R
1651#	_return		W
1652#	_setup		R
1653#
1654_run_rc_offcmd()
1655{
1656	eval _offcmd=\$${name}_offcmd
1657	if [ -n "$_offcmd" ]; then
1658		if [ -n "$_env" ]; then
1659			eval "export -- $_env"
1660		fi
1661		debug "run_rc_command: ${name}_offcmd: $_offcmd $rc_extra_args"
1662		eval "$_offcmd $rc_extra_args"
1663		_return=$?
1664	fi
1665	return 0
1666}
1667
1668_run_rc_precmd()
1669{
1670	check_required_before "$rc_arg" || return 1
1671
1672	if [ -n "$_precmd" ]; then
1673		debug "run_rc_command: ${rc_arg}_precmd: $_precmd $rc_extra_args"
1674		eval "$_precmd $rc_extra_args"
1675		_return=$?
1676
1677		# If precmd failed and force isn't set, request exit.
1678		if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
1679			return 1
1680		fi
1681	fi
1682
1683	check_required_after "$rc_arg" || return 1
1684
1685	return 0
1686}
1687
1688_run_rc_postcmd()
1689{
1690	if [ -n "$_postcmd" ]; then
1691		debug "run_rc_command: ${rc_arg}_postcmd: $_postcmd $rc_extra_args"
1692		eval "$_postcmd $rc_extra_args"
1693		_return=$?
1694	fi
1695	return 0
1696}
1697
1698_run_rc_setup()
1699{
1700	# prevent multiple execution on restart => stop/start split
1701	if ! ${_rc_restart_done:-false} && [ -n "$_setup" ]; then
1702		debug "run_rc_command: ${rc_arg}_setup: $_setup"
1703		eval "$_setup"
1704		_return=$?
1705		if [ $_return -ne 0 ]; then
1706			return 1
1707		fi
1708	fi
1709	return 0
1710}
1711
1712_run_rc_doit()
1713{
1714	local _m
1715
1716	debug "run_rc_command: doit: $*"
1717	_m=$(umask)
1718	${_umask:+umask ${_umask}}
1719	eval "$@"
1720	_return=$?
1721	umask ${_m}
1722
1723	# If command failed and force isn't set, request exit.
1724	if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
1725		return 1
1726	fi
1727
1728	return 0
1729}
1730
1731_run_rc_notrunning()
1732{
1733	local _pidmsg
1734
1735	if [ -n "$pidfile" ]; then
1736		_pidmsg=" (check $pidfile)."
1737	else
1738		_pidmsg=
1739	fi
1740	echo 1>&2 "${name} not running?${_pidmsg}"
1741}
1742
1743_run_rc_killcmd()
1744{
1745	local _cmd
1746
1747	_cmd="kill -$1 $rc_pid"
1748	if [ -n "$_user" ]; then
1749		_cmd="su -m ${_user} -c 'sh -c \"${_cmd}\"'"
1750	fi
1751	echo "$_cmd"
1752}
1753
1754#
1755# run_rc_script file arg
1756#	Start the script `file' with `arg', and correctly handle the
1757#	return value from the script.
1758#	If `file' ends with `.sh' and lives in /etc/rc.d, ignore it as it's
1759#	an old-style startup file.
1760#	If `file' ends with `.sh' and does not live in /etc/rc.d, it's sourced
1761#	into the current environment if $rc_fast_and_loose is set; otherwise
1762#	it is run as a child process.
1763#	If `file' appears to be a backup or scratch file, ignore it.
1764#	Otherwise if it is executable run as a child process.
1765#
1766run_rc_script()
1767{
1768	_file=$1
1769	_arg=$2
1770	if [ -z "$_file" -o -z "$_arg" ]; then
1771		err 3 'USAGE: run_rc_script file arg'
1772	fi
1773
1774	unset	name command command_args command_interpreter \
1775		extra_commands pidfile procname \
1776		rcvar rcvars rcvars_obsolete required_dirs required_files \
1777		required_vars
1778	eval unset ${_arg}_cmd ${_arg}_precmd ${_arg}_postcmd
1779
1780	rc_trace 0 "$_file $_arg"
1781	# don't use it if we don't trust it
1782	is_verified $_file || return
1783
1784	rc_service="$_file"
1785	case "$_file" in
1786	/etc/rc.d/*.sh)			# no longer allowed in the base
1787		warn "Ignoring old-style startup script $_file"
1788		;;
1789	*[~#]|*.OLD|*.bak|*.orig|*,v)	# scratch file; skip
1790		warn "Ignoring scratch file $_file"
1791		;;
1792	*)				# run in subshell
1793		if [ -x $_file ]; then
1794			DebugOn $_file $_file:$_arg rc:${_file##*/} rc:${_file##*/}:$_arg ${_file##*/} ${_file##*/}:$_arg
1795
1796			if [ -n "$rc_boottrace" ]; then
1797				boottrace_fn "$_file" "$_arg"
1798			elif [ -n "$rc_fast_and_loose" ]; then
1799				set $_arg; . $_file
1800			else
1801				( trap "echo Script $_file interrupted >&2 ; kill -QUIT $$" 3
1802				  trap "echo Script $_file interrupted >&2 ; exit 1" 2
1803				  trap "echo Script $_file running >&2" 29
1804				  set $_arg; . $_file )
1805			fi
1806			DebugOff $_file $_file:$_arg rc:${_file##*/} rc:${_file##*/}:$_arg ${_file##*/} ${_file##*/}:$_arg
1807		fi
1808		;;
1809	esac
1810}
1811
1812#
1813# run_rc_scripts [options] file [...]
1814#
1815# Call `run_rc_script' for each "file" unless already listed in
1816# $_rc_elem_done.
1817#
1818# Options:
1819#
1820#	--arg "arg"
1821#		Pass "arg" to `run_rc_script' default is $_boot.
1822#
1823#	--break "marker"
1824#		If any "file" matches "marker" stop processing.
1825#
1826_rc_elem_done=
1827run_rc_scripts()
1828{
1829	local _arg=${_boot}
1830	local _rc_elem
1831	local _rc_breaks=
1832
1833	while :; do
1834		case "$1" in
1835		--arg)
1836                        _arg="$2"
1837                        shift 2
1838                        ;;
1839		--break)
1840                        _rc_breaks="$_rc_breaks $2"
1841                        shift 2
1842                        ;;
1843		*)
1844                        break
1845                        ;;
1846		esac
1847	done
1848	for _rc_elem in "$@"; do
1849		: _rc_elem=$_rc_elem
1850		case " $_rc_elem_done " in
1851		*" $_rc_elem "*)
1852                        continue
1853                        ;;
1854		esac
1855		run_rc_script ${_rc_elem} ${_arg}
1856		_rc_elem_done="$_rc_elem_done $_rc_elem"
1857		case " $_rc_breaks " in
1858		*" ${_rc_elem##*/} "*)
1859                        break
1860                        ;;
1861		esac
1862	done
1863}
1864
1865boottrace_fn()
1866{
1867	local _file _arg
1868	_file=$1
1869	_arg=$2
1870
1871	if [ -n "$rc_fast_and_loose" ]; then
1872		boottrace_sysctl "$_file start"
1873		set $_arg; . $_file
1874		boottrace_sysctl "$_file done"
1875	else
1876		_boot="${_boot}" rc_fast="${rc_fast}" autoboot="${autoboot}" \
1877		    $boottrace_cmd "$_file" "$_arg"
1878	fi
1879}
1880
1881boottrace_sysctl()
1882{
1883	${SYSCTL} kern.boottrace.boottrace="$1"
1884}
1885
1886#
1887# load_rc_config [service]
1888#	Source in the configuration file(s) for a given service.
1889#	If no service is specified, only the global configuration
1890#	file(s) will be loaded.
1891#
1892load_rc_config()
1893{
1894	local _name _rcvar_val _var _defval _v _msg _new _d _dot
1895	_name=$1
1896	_dot=${load_rc_config_reader:-dot}
1897
1898	case "$_dot" in
1899	dot|[sv]dot)
1900		;;
1901	*)	warn "Ignoring invalid load_rc_config_reader"
1902		_dot=dot
1903		;;
1904	esac
1905	case "$1" in
1906	-s|--safe)
1907                _dot=sdot
1908                _name=$2
1909                shift
1910                ;;
1911	-v|--verify)
1912                _dot=vdot
1913                _name=$2
1914                shift
1915                ;;
1916	esac
1917
1918	DebugOn rc:$_name $_name
1919
1920	if ${_rc_conf_loaded:-false}; then
1921		:
1922	else
1923		if [ -r /etc/defaults/rc.conf ]; then
1924			debug "Sourcing /etc/defaults/rc.conf"
1925			$_dot /etc/defaults/rc.conf
1926			source_rc_confs
1927		elif [ -r /etc/rc.conf ]; then
1928			debug "Sourcing /etc/rc.conf (/etc/defaults/rc.conf doesn't exist)."
1929			$_dot /etc/rc.conf
1930		fi
1931		_rc_conf_loaded=true
1932	fi
1933
1934	# If a service name was specified, attempt to load
1935	# service-specific configuration
1936	if [ -n "$_name" ] ; then
1937		for _d in /etc ${local_startup}; do
1938			_d=${_d%/rc.d}
1939			if [ -f ${_d}/rc.conf.d/"$_name" ]; then
1940				debug "Sourcing ${_d}/rc.conf.d/$_name"
1941				$_dot ${_d}/rc.conf.d/"$_name"
1942			elif [ -d ${_d}/rc.conf.d/"$_name" ] ; then
1943				local _rc
1944				for _rc in ${_d}/rc.conf.d/"$_name"/* ; do
1945					if [ -f "$_rc" ] ; then
1946						debug "Sourcing $_rc"
1947						$_dot "$_rc"
1948					fi
1949				done
1950			fi
1951		done
1952	fi
1953
1954	# Set defaults if defined.
1955	for _var in $rcvar $rcvars; do
1956		eval _defval=\$${_var}_defval
1957		if [ -n "$_defval" ]; then
1958			eval : \${$_var:=\$${_var}_defval}
1959		fi
1960	done
1961
1962	# check obsolete rc.conf variables
1963	for _var in $rcvars_obsolete; do
1964		eval _v=\$$_var
1965		eval _msg=\$${_var}_obsolete_msg
1966		eval _new=\$${_var}_newvar
1967		case $_v in
1968		"")
1969			;;
1970		*)
1971			if [ -z "$_new" ]; then
1972				_msg="Ignored."
1973			else
1974				eval $_new=\"\$$_var\"
1975				if [ -z "$_msg" ]; then
1976					_msg="Use \$$_new instead."
1977				fi
1978			fi
1979			warn "\$$_var is obsolete.  $_msg"
1980			;;
1981		esac
1982	done
1983}
1984
1985#
1986# load_rc_config_var name var
1987#	Read the rc.conf(5) var for name and set in the
1988#	current shell, using load_rc_config in a subshell to prevent
1989#	unwanted side effects from other variable assignments.
1990#
1991load_rc_config_var()
1992{
1993	if [ $# -ne 2 ]; then
1994		err 3 'USAGE: load_rc_config_var name var'
1995	fi
1996	eval $(eval '(
1997		load_rc_config '$1' >/dev/null;
1998		if [ -n "${'$2'}" -o "${'$2'-UNSET}" != "UNSET" ]; then
1999			echo '$2'=\'\''${'$2'}\'\'';
2000		fi
2001	)' )
2002}
2003
2004#
2005# rc_usage commands
2006#	Print a usage string for $0, with `commands' being a list of
2007#	valid commands.
2008#
2009rc_usage()
2010{
2011	echo -n 1>&2 "Usage: $0 [fast|force|one|quiet]("
2012
2013	_sep=
2014	for _elem; do
2015		echo -n 1>&2 "$_sep$_elem"
2016		_sep="|"
2017	done
2018	echo 1>&2 ")"
2019	exit 1
2020}
2021
2022#
2023# err exitval message
2024#	Display message to stderr and log to the syslog, and exit with exitval.
2025#
2026err()
2027{
2028	exitval=$1
2029	shift
2030
2031	if [ -x /usr/bin/logger ]; then
2032		logger "$0: ERROR: $*"
2033	fi
2034	echo 1>&2 "$0: ERROR: $*"
2035	exit $exitval
2036}
2037
2038#
2039# warn message
2040#	Display message to stderr and log to the syslog.
2041#
2042warn()
2043{
2044	if [ -x /usr/bin/logger ]; then
2045		logger "$0: WARNING: $*"
2046	fi
2047	echo 1>&2 "$0: WARNING: $*"
2048}
2049
2050#
2051# info message
2052#	Display informational message to stdout and log to syslog.
2053#
2054info()
2055{
2056	case ${rc_info} in
2057	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
2058		if [ -x /usr/bin/logger ]; then
2059			logger "$0: INFO: $*"
2060		fi
2061		echo "$0: INFO: $*"
2062		;;
2063	esac
2064}
2065
2066#
2067# debug message
2068#	If debugging is enabled in rc.conf output message to stderr.
2069#	BEWARE that you don't call any subroutine that itself calls this
2070#	function.
2071#
2072debug()
2073{
2074	case ${rc_debug} in
2075	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
2076		if [ -x /usr/bin/logger ]; then
2077			logger "$0: DEBUG: $*"
2078		fi
2079		echo 1>&2 "$0: DEBUG: $*"
2080		;;
2081	esac
2082}
2083
2084#
2085# backup_file action file cur backup
2086#	Make a backup copy of `file' into `cur', and save the previous
2087#	version of `cur' as `backup'.
2088#
2089#	The `action' keyword can be one of the following:
2090#
2091#	add		`file' is now being backed up (and is possibly
2092#			being reentered into the backups system).  `cur'
2093#			is created.
2094#
2095#	update		`file' has changed and needs to be backed up.
2096#			If `cur' exists, it is copied to `back'
2097#			and then `file' is copied to `cur'.
2098#
2099#	remove		`file' is no longer being tracked by the backups
2100#			system.  `cur' is moved `back'.
2101#
2102#
2103backup_file()
2104{
2105	_action=$1
2106	_file=$2
2107	_cur=$3
2108	_back=$4
2109
2110	case $_action in
2111	add|update)
2112		if [ -f $_cur ]; then
2113			cp -p $_cur $_back
2114		fi
2115		cp -p $_file $_cur
2116		chown root:wheel $_cur
2117		;;
2118	remove)
2119		mv -f $_cur $_back
2120		;;
2121	esac
2122}
2123
2124# make_symlink src link
2125#	Make a symbolic link 'link' to src from basedir. If the
2126#	directory in which link is to be created does not exist
2127#	a warning will be displayed and an error will be returned.
2128#	Returns 0 on success, 1 otherwise.
2129#
2130make_symlink()
2131{
2132	local src link linkdir _me
2133	src="$1"
2134	link="$2"
2135	linkdir="`dirname $link`"
2136	_me="make_symlink()"
2137
2138	if [ -z "$src" -o -z "$link" ]; then
2139		warn "$_me: requires two arguments."
2140		return 1
2141	fi
2142	if [ ! -d "$linkdir" ]; then
2143		warn "$_me: the directory $linkdir does not exist."
2144		return 1
2145	fi
2146	if ! ln -sf $src $link; then
2147		warn "$_me: unable to make a symbolic link from $link to $src"
2148		return 1
2149	fi
2150	return 0
2151}
2152
2153# devfs_rulesets_from_file file
2154#	Reads a set of devfs commands from file, and creates
2155#	the specified rulesets with their rules. Returns non-zero
2156#	if there was an error.
2157#
2158devfs_rulesets_from_file()
2159{
2160	local file _err _me _opts
2161	file="$1"
2162	_me="devfs_rulesets_from_file"
2163	_err=0
2164
2165	if [ -z "$file" ]; then
2166		warn "$_me: you must specify a file"
2167		return 1
2168	fi
2169	if [ ! -e "$file" ]; then
2170		debug "$_me: no such file ($file)"
2171		return 0
2172	fi
2173
2174	# Disable globbing so that the rule patterns are not expanded
2175	# by accident with matching filesystem entries.
2176	_opts=$-; set -f
2177
2178	debug "reading rulesets from file ($file)"
2179	{ while read line
2180	do
2181		case $line in
2182		\#*)
2183			continue
2184			;;
2185		\[*\]*)
2186			rulenum=`expr "$line" : "\[.*=\([0-9]*\)\]"`
2187			if [ -z "$rulenum" ]; then
2188				warn "$_me: cannot extract rule number ($line)"
2189				_err=1
2190				break
2191			fi
2192			rulename=`expr "$line" : "\[\(.*\)=[0-9]*\]"`
2193			if [ -z "$rulename" ]; then
2194				warn "$_me: cannot extract rule name ($line)"
2195				_err=1
2196				break;
2197			fi
2198			eval $rulename=\$rulenum
2199			debug "found ruleset: $rulename=$rulenum"
2200			if ! /sbin/devfs rule -s $rulenum delset; then
2201				_err=1
2202				break
2203			fi
2204			;;
2205		*)
2206			rulecmd="${line%%"\#*"}"
2207			# evaluate the command incase it includes
2208			# other rules
2209			if [ -n "$rulecmd" ]; then
2210				debug "adding rule ($rulecmd)"
2211				if ! eval /sbin/devfs rule -s $rulenum $rulecmd
2212				then
2213					_err=1
2214					break
2215				fi
2216			fi
2217			;;
2218		esac
2219		if [ $_err -ne 0 ]; then
2220			debug "error in $_me"
2221			break
2222		fi
2223	done } < $file
2224	case $_opts in *f*) ;; *) set +f ;; esac
2225	return $_err
2226}
2227
2228# devfs_init_rulesets
2229#	Initializes rulesets from configuration files. Returns
2230#	non-zero if there was an error.
2231#
2232devfs_init_rulesets()
2233{
2234	local file _me
2235	_me="devfs_init_rulesets"
2236
2237	# Go through this only once
2238	if [ -n "$devfs_rulesets_init" ]; then
2239		debug "$_me: devfs rulesets already initialized"
2240		return
2241	fi
2242	for file in $devfs_rulesets; do
2243		if ! devfs_rulesets_from_file $file; then
2244			warn "$_me: could not read rules from $file"
2245			return 1
2246		fi
2247	done
2248	devfs_rulesets_init=1
2249	debug "$_me: devfs rulesets initialized"
2250	return 0
2251}
2252
2253# devfs_set_ruleset ruleset [dir]
2254#	Sets the default ruleset of dir to ruleset. The ruleset argument
2255#	must be a ruleset name as specified in devfs.rules(5) file.
2256#	Returns non-zero if it could not set it successfully.
2257#
2258devfs_set_ruleset()
2259{
2260	local devdir rs _me
2261	[ -n "$1" ] && eval rs=\$$1 || rs=
2262	[ -n "$2" ] && devdir="-m "$2"" || devdir=
2263	_me="devfs_set_ruleset"
2264
2265	if [ -z "$rs" ]; then
2266		warn "$_me: you must specify a ruleset number"
2267		return 1
2268	fi
2269	debug "$_me: setting ruleset ($rs) on mount-point (${devdir#-m })"
2270	if ! /sbin/devfs $devdir ruleset $rs; then
2271		warn "$_me: unable to set ruleset $rs to ${devdir#-m }"
2272		return 1
2273	fi
2274	return 0
2275}
2276
2277# devfs_apply_ruleset ruleset [dir]
2278#	Apply ruleset number $ruleset to the devfs mountpoint $dir.
2279#	The ruleset argument must be a ruleset name as specified
2280#	in a devfs.rules(5) file.  Returns 0 on success or non-zero
2281#	if it could not apply the ruleset.
2282#
2283devfs_apply_ruleset()
2284{
2285	local devdir rs _me
2286	[ -n "$1" ] && eval rs=\$$1 || rs=
2287	[ -n "$2" ] && devdir="-m "$2"" || devdir=
2288	_me="devfs_apply_ruleset"
2289
2290	if [ -z "$rs" ]; then
2291		warn "$_me: you must specify a ruleset"
2292		return 1
2293	fi
2294	debug "$_me: applying ruleset ($rs) to mount-point (${devdir#-m })"
2295	if ! /sbin/devfs $devdir rule -s $rs applyset; then
2296		warn "$_me: unable to apply ruleset $rs to ${devdir#-m }"
2297		return 1
2298	fi
2299	return 0
2300}
2301
2302# devfs_domount dir [ruleset]
2303#	Mount devfs on dir. If ruleset is specified it is set
2304#	on the mount-point. It must also be a ruleset name as specified
2305#	in a devfs.rules(5) file. Returns 0 on success.
2306#
2307devfs_domount()
2308{
2309	local devdir rs _me
2310	devdir="$1"
2311	[ -n "$2" ] && rs=$2 || rs=
2312	_me="devfs_domount()"
2313
2314	if [ -z "$devdir" ]; then
2315		warn "$_me: you must specify a mount-point"
2316		return 1
2317	fi
2318	debug "$_me: mount-point is ($devdir), ruleset is ($rs)"
2319	if ! mount -t devfs dev "$devdir"; then
2320		warn "$_me: Unable to mount devfs on $devdir"
2321		return 1
2322	fi
2323	if [ -n "$rs" ]; then
2324		devfs_init_rulesets
2325		devfs_set_ruleset $rs $devdir
2326		devfs -m $devdir rule applyset
2327	fi
2328	return 0
2329}
2330
2331# Provide a function for normalizing the mounting of memory
2332# filesystems.  This should allow the rest of the code here to remain
2333# as close as possible between 5-current and 4-stable.
2334#   $1 = size
2335#   $2 = mount point
2336#   $3 = (optional) extra mdmfs flags
2337mount_md()
2338{
2339	if [ -n "$3" ]; then
2340		flags="$3"
2341	fi
2342	/sbin/mdmfs $flags -s $1 ${mfs_type} $2
2343}
2344
2345# Code common to scripts that need to load a kernel module
2346# if it isn't in the kernel yet. Syntax:
2347#   load_kld [-e regex] [-m module] file
2348# where -e or -m chooses the way to check if the module
2349# is already loaded:
2350#   regex is egrep'd in the output from `kldstat -v',
2351#   module is passed to `kldstat -m'.
2352# The default way is as though `-m file' were specified.
2353load_kld()
2354{
2355	local _loaded _mod _opt _re
2356
2357	while getopts "e:m:" _opt; do
2358		case "$_opt" in
2359		e) _re="$OPTARG" ;;
2360		m) _mod="$OPTARG" ;;
2361		*) err 3 'USAGE: load_kld [-e regex] [-m module] file' ;;
2362		esac
2363	done
2364	shift $(($OPTIND - 1))
2365	if [ $# -ne 1 ]; then
2366		err 3 'USAGE: load_kld [-e regex] [-m module] file'
2367	fi
2368	_mod=${_mod:-$1}
2369	_loaded=false
2370	if [ -n "$_re" ]; then
2371		if kldstat -v | egrep -q -e "$_re"; then
2372			_loaded=true
2373		fi
2374	else
2375		if kldstat -q -m "$_mod"; then
2376			_loaded=true
2377		fi
2378	fi
2379	if ! $_loaded; then
2380		if ! kldload "$1"; then
2381			warn "Unable to load kernel module $1"
2382			return 1
2383		else
2384			info "$1 kernel module loaded."
2385			if [ -f "/etc/sysctl.kld.d/$1.conf" ]; then
2386				sysctl -f "/etc/sysctl.kld.d/$1.conf"
2387			fi
2388		fi
2389	else
2390		debug "load_kld: $1 kernel module already loaded."
2391	fi
2392	return 0
2393}
2394
2395# ltr str src dst [var]
2396#	Change every $src in $str to $dst.
2397#	Useful when /usr is not yet mounted and we cannot use tr(1), sed(1) nor
2398#	awk(1). If var is non-NULL, set it to the result.
2399ltr()
2400{
2401	local _str _src _dst _out _com _var
2402	_str="$1"
2403	_src="$2"
2404	_dst="$3"
2405	_var="$4"
2406	_out=""
2407
2408	local IFS="${_src}"
2409	for _com in ${_str}; do
2410		if [ -z "${_out}" ]; then
2411			_out="${_com}"
2412		else
2413			_out="${_out}${_dst}${_com}"
2414		fi
2415	done
2416	if [ -n "${_var}" ]; then
2417		setvar "${_var}" "${_out}"
2418	else
2419		echo "${_out}"
2420	fi
2421}
2422
2423# Creates a list of providers for GELI encryption.
2424geli_make_list()
2425{
2426	local devices devices2
2427	local provider mountpoint type options rest
2428
2429	# Create list of GELI providers from fstab.
2430	while read provider mountpoint type options rest ; do
2431		case ":${options}" in
2432		:*noauto*)
2433			noauto=yes
2434			;;
2435		*)
2436			noauto=no
2437			;;
2438		esac
2439
2440		case ":${provider}" in
2441		:#*)
2442			continue
2443			;;
2444		*.eli)
2445			# Skip swap devices.
2446			if [ "${type}" = "swap" -o "${options}" = "sw" -o "${noauto}" = "yes" ]; then
2447				continue
2448			fi
2449			devices="${devices} ${provider}"
2450			;;
2451		esac
2452	done < /etc/fstab
2453
2454	# Append providers from geli_devices.
2455	devices="${devices} ${geli_devices}"
2456
2457	for provider in ${devices}; do
2458		provider=${provider%.eli}
2459		provider=${provider#/dev/}
2460		devices2="${devices2} ${provider}"
2461	done
2462
2463	echo ${devices2}
2464}
2465
2466# Originally, root mount hold had to be released before mounting
2467# the root filesystem.  This delayed the boot, so it was changed
2468# to only wait if the root device isn't readily available.  This
2469# can result in rc scripts executing before all the devices - such
2470# as graid(8), or USB disks - can be accessed.  This function can
2471# be used to explicitly wait for root mount holds to be released.
2472root_hold_wait()
2473{
2474	local wait waited holders
2475
2476	waited=0
2477	while true; do
2478		holders="$(sysctl -n vfs.root_mount_hold)"
2479		if [ -z "${holders}" ]; then
2480			break;
2481		fi
2482		if [ ${waited} -eq 0 ]; then
2483			echo -n "Waiting ${root_hold_delay}s" \
2484			"for the root mount holders: ${holders}"
2485		else
2486			echo -n .
2487		fi
2488		if [ ${waited} -ge ${root_hold_delay} ]; then
2489			echo
2490			break
2491		fi
2492		sleep 1
2493		waited=$(($waited + 1))
2494	done
2495}
2496
2497# Find scripts in local_startup directories that use the old syntax
2498#
2499find_local_scripts_old() {
2500	zlist=''
2501	slist=''
2502	for dir in ${local_startup}; do
2503		if [ -d "${dir}" ]; then
2504			for file in ${dir}/[0-9]*.sh; do
2505				grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
2506				    continue
2507				zlist="$zlist $file"
2508			done
2509			for file in ${dir}/[!0-9]*.sh; do
2510				grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
2511				    continue
2512				slist="$slist $file"
2513			done
2514		fi
2515	done
2516}
2517
2518find_local_scripts_new() {
2519	local_rc=''
2520	for dir in ${local_startup}; do
2521		if [ -d "${dir}" ]; then
2522			for file in `grep -l '^# PROVIDE:' ${dir}/* 2>/dev/null`; do
2523				case "$file" in
2524				*.sample|*.pkgsave) ;;
2525				*)	if [ -x "$file" ]; then
2526						local_rc="${local_rc} ${file}"
2527					fi
2528					;;
2529				esac
2530			done
2531		fi
2532	done
2533}
2534
2535find_system_scripts() {
2536	system_rc=''
2537	for file in /etc/rc.d/*; do
2538		case "${file##*/}" in
2539		*.pkgsave) ;;
2540		*)	if [ -x "$file" ]; then
2541				system_rc="${system_rc} ${file}"
2542			fi
2543			;;
2544		esac
2545	done
2546}
2547
2548# check_required_{before|after} command
2549#	Check for things required by the command before and after its precmd,
2550#	respectively.  The two separate functions are needed because some
2551#	conditions should prevent precmd from being run while other things
2552#	depend on precmd having already been run.
2553#
2554check_required_before()
2555{
2556	local _f
2557
2558	case "$1" in
2559	start)
2560		for _f in $required_vars; do
2561			if ! checkyesno $_f; then
2562				warn "\$${_f} is not enabled."
2563				if [ -z "$rc_force" ]; then
2564					return 1
2565				fi
2566			fi
2567		done
2568
2569		for _f in $required_dirs; do
2570			if [ ! -d "${_f}/." ]; then
2571				warn "${_f} is not a directory."
2572				if [ -z "$rc_force" ]; then
2573					return 1
2574				fi
2575			fi
2576		done
2577
2578		for _f in $required_files; do
2579			if [ ! -r "${_f}" ]; then
2580				warn "${_f} is not readable."
2581				if [ -z "$rc_force" ]; then
2582					return 1
2583				fi
2584			fi
2585		done
2586		;;
2587	esac
2588
2589	return 0
2590}
2591
2592check_required_after()
2593{
2594	local _f _args
2595
2596	case "$1" in
2597	start)
2598		for _f in $required_modules; do
2599			case "${_f}" in
2600				*~*)	_args="-e ${_f#*~} ${_f%%~*}" ;;
2601				*:*)	_args="-m ${_f#*:} ${_f%%:*}" ;;
2602				*)	_args="${_f}" ;;
2603			esac
2604			if ! load_kld ${_args}; then
2605				if [ -z "$rc_force" ]; then
2606					return 1
2607				fi
2608			fi
2609		done
2610		;;
2611	esac
2612
2613	return 0
2614}
2615
2616# check_jail mib
2617#	Return true if security.jail.$mib exists and set to 1.
2618
2619check_jail()
2620{
2621	local _mib _v
2622
2623	_mib=$1
2624	if _v=$(${SYSCTL_N} "security.jail.$_mib" 2> /dev/null); then
2625		case $_v in
2626		1)	return 0;;
2627		esac
2628	fi
2629	return 1
2630}
2631
2632# check_kern_features mib
2633#	Return existence of kern.features.* sysctl MIB as true or
2634#	false.  The result will be cached in $_rc_cache_kern_features_
2635#	namespace.  "0" means the kern.features.X exists.
2636
2637check_kern_features()
2638{
2639	local _v
2640
2641	[ -n "$1" ] || return 1;
2642	eval _v=\$_rc_cache_kern_features_$1
2643	[ -n "$_v" ] && return "$_v";
2644
2645	if ${SYSCTL_N} kern.features.$1 > /dev/null 2>&1; then
2646		eval _rc_cache_kern_features_$1=0
2647		return 0
2648	else
2649		eval _rc_cache_kern_features_$1=1
2650		return 1
2651	fi
2652}
2653
2654# check_namevarlist var
2655#	Return "0" if ${name}_var is reserved in rc.subr.
2656
2657_rc_namevarlist="program chroot chdir env flags fib nice user group groups prepend setup"
2658check_namevarlist()
2659{
2660	local _v
2661
2662	for _v in $_rc_namevarlist; do
2663	case $1 in
2664	$_v)	return 0 ;;
2665	esac
2666	done
2667
2668	return 1
2669}
2670
2671# _echoonce var msg mode
2672#	mode=0: Echo $msg if ${$var} is empty.
2673#	        After doing echo, a string is set to ${$var}.
2674#
2675#	mode=1: Echo $msg if ${$var} is a string with non-zero length.
2676#
2677_echoonce()
2678{
2679	local _var _msg _mode
2680	eval _var=\$$1
2681	_msg=$2
2682	_mode=$3
2683
2684	case $_mode in
2685	1)	[ -n "$_var" ] && echo "$_msg" ;;
2686	*)	[ -z "$_var" ] && echo -n "$_msg" && eval "$1=finished" ;;
2687	esac
2688}
2689
2690# If the loader env variable rc.debug is set, turn on debugging. rc.conf will
2691# still override this, but /etc/defaults/rc.conf can't unconditionally set this
2692# since it would undo what we've done here.
2693if kenv -q rc.debug > /dev/null ; then
2694	rc_debug=YES
2695fi
2696
2697boottrace_cmd=`command -v boottrace`
2698if [ -n "$boottrace_cmd" ] && [ "`${SYSCTL_N} -q kern.boottrace.enabled`" = "1" ]; then
2699	rc_boottrace=YES
2700fi
2701
2702SED=${SED:-$(Exists -x /usr/bin/sed /rescue/sed)}
2703
2704# Allow for local additions and overrides.
2705# Use vdot to ensure the file has not been tampered with.
2706vdot /etc/local.rc.subr
2707
2708# Avoid noise - when we do not have /usr mounted,
2709# and we cannot use safe_dot without sed.
2710if ! have basename; then
2711	basename()
2712	{
2713		local b=${1%$2}
2714		echo ${b##*/}
2715	}
2716	tty()
2717	{
2718		return 0
2719	}
2720	# we cannot use safe_dot without sed
2721	[ -z "$SED" ] && _SAFE_EVAL_SH=:
2722fi
2723# safe_eval.sh provides safe_dot - for untrusted files
2724$_SAFE_EVAL_SH vdot /libexec/safe_eval.sh
2725$_DEBUG_SH vdot /libexec/debug.sh
2726
2727# Ensure we can still operate if debug.sh and
2728# safe_eval.sh are not found.
2729if have DebugOn; then
2730	# allow DEBUG_SH to be set from loader prompt
2731	DEBUG_SH=${DEBUG_SH:-$(kenv -q DEBUG_SH)}
2732else
2733	DebugOn() { return 0; }
2734	DebugOff() { return 0; }
2735fi
2736if ! have save_dot; then
2737	safe_dot() { dot "$@"; }
2738fi
2739